var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

window.addEventListener("DOMContentLoaded",checkCode,false);

function checkCode(){
oPrefs.setBoolPref("procon.authenticated", false);
if ( oPrefs.prefHasUserValue("procon.password") ) {
	  var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
		input = {value:""};
		check = {value:false};
	   var title = document.getElementById("bundle_procon").getString("askTitle");
		var description = document.getElementById("bundle_procon").getString("askPassword");
		okorcancel = prompts.promptPassword(null, title, description, input, null, check);
		var password = oPrefs.getCharPref("procon.password");
	if( okorcancel && hex_md5(input.value) === password){
		oPrefs.setBoolPref("procon.authenticated", true);
		return;
	}else{
		prompts.alert(null, title, document.getElementById("bundle_procon").getString("WrongpassMessage"));
		window.close(); 
		return;
	}
	}
	oPrefs.setBoolPref("procon.authenticated", true);
	return;
}

function onLoad() {
document.getElementById("pref-hideTM").checked = oPrefs.getBoolPref("procon.htm");
document.getElementById("pref-statusbar").checked = oPrefs.getBoolPref("procon.pstatus");
document.getElementById("pref-addons").checked = oPrefs.getBoolPref("procon.addons");
document.getElementById("pref-aboutconfig").checked = oPrefs.getBoolPref("procon.abl");
document.getElementById("pref-enableRealTime").checked = oPrefs.getBoolPref("procon.enableRealTime");
document.getElementById("pref-enableRealTimeWhiteList").checked = oPrefs.getBoolPref("procon.enableRealTimeWhiteList");
document.getElementById("shortcut").value = oPrefs.getCharPref("procon.shortcut").toUpperCase();
document.getElementById("enabled").checked = oPrefs.getBoolPref("procon.enabled");
document.getElementById("stopAll").checked = oPrefs.getBoolPref("procon.bat");
document.getElementById("psit").value = oPrefs.getCharPref("procon.psit");
document.getElementById("pcust").checked = oPrefs.getBoolPref("procon.pcust");
document.getElementById("trustedcheck").checked = oPrefs.getBoolPref("procon.enableWhiteList");
document.getElementById("profanitycheck").checked = oPrefs.getBoolPref("procon.filteron");

   if (oPrefs.getBoolPref("procon.enabled") === true){
    document.getElementById("filstat").src="chrome://procon/content/immagini/on.gif";
   }else{
    document.getElementById("filstat").src="chrome://procon/content/immagini/off.gif";
   } 
   if (oPrefs.getBoolPref("procon.filteron") === true){
    document.getElementById("censtat").src="chrome://procon/content/immagini/on.gif";
   }else{
    document.getElementById("censtat").src="chrome://procon/content/immagini/off.gif";
   } 
   if (oPrefs.getBoolPref("procon.enableWhiteList") === true){
    document.getElementById("wliststat").src="chrome://procon/content/immagini/on.gif";
   }else{
    document.getElementById("wliststat").src="chrome://procon/content/immagini/off.gif";
   } 
   
   

   if ( oPrefs.prefHasUserValue("procon.lvl") ) {
		var valuemen = oPrefs.getIntPref("procon.lvl");
		var list = document.getElementById("levels");
		list.selectedIndex = valuemen;
   }
   else {
    var list = document.getElementById("levels");
		list.value = 1;
   }
   if(oPrefs.prefHasUserValue("procon.psit")){
   document.getElementById("psit").value = oPrefs.getCharPref("procon.psit");
   }
   //check if filter settings are respected
   if(document.getElementById("levels").selectedIndex !== 1){
    //for the secure
	if(document.getElementById("levels").selectedIndex === 0){
	  if(document.getElementById("stopAll").checked!==true){
		document.getElementById("levels").selectedIndex = 1;
	  }
	  if(document.getElementById("enabled").checked!==true){
		document.getElementById("levels").selectedIndex = 1;
	  }
	}
	//for the light
	if(document.getElementById("levels").selectedIndex === 2){
	  if(document.getElementById("stopAll").checked!==false){
		document.getElementById("levels").selectedIndex = 1;
	  }
	  if(document.getElementById("enabled").checked!==true){
		document.getElementById("levels").selectedIndex = 1;
	  }	
	}
   }
   changeme();
   
   if ( oPrefs.prefHasUserValue("procon.whiteList") ) {
   var value = oPrefs.getComplexValue("procon.whiteList",
      Components.interfaces.nsISupportsString).data;
	  document.getElementById("whiteList").value = value;
   }
   else {
      document.getElementById("whiteList").value=document.getElementById("bundle_regex").getString("defaultwhiteListregex");
   }
   
   if ( oPrefs.prefHasUserValue("procon.wordlist") ) {
   var value2 = oPrefs.getComplexValue("procon.wordlist",
      Components.interfaces.nsISupportsString).data;
	  document.getElementById("wordList").value = value2;
   }
   else {
      document.getElementById("wordList").value=document.getElementById("bundle_regex").getString("defaultprofanity");
   }
   
   if ( oPrefs.prefHasUserValue("procon.customCens") ) {
   var value3 = oPrefs.getComplexValue("procon.customCens",
      Components.interfaces.nsISupportsString).data;
	  document.getElementById("customCens").value = value3;
   }
   else {
      document.getElementById("customCens").value="***";
   }  

}

function changeme() {
if (document.getElementById("pcust").checked){
document.getElementById("psit").disabled = false;
}
else{
document.getElementById("psit").disabled = true;
}
}

function lvl0() {
document.getElementById("stopAll").checked = true;
document.getElementById("enabled").checked = true;
if ( oPrefs.prefHasUserValue("procon.whiteList") ) {
oPrefs.setBoolPref("procon.enableWhiteList", true);
}
oPrefs.setIntPref("procon.action", 2);
}

function lvl1() {
document.getElementById("stopAll").checked = false;
document.getElementById("enabled").checked = true;
if ( oPrefs.prefHasUserValue("procon.whiteList") ) {
oPrefs.setBoolPref("procon.enableWhiteList", true);
}
oPrefs.setIntPref("procon.action", 2);
}

function lvl2() {
document.getElementById("stopAll").checked = false;
document.getElementById("enabled").checked = true;
oPrefs.setBoolPref("procon.enableWhiteList", false);
oPrefs.setIntPref("procon.action", 1);
}

function resetAll() {
 var k = false;
  k = confirm(document.getElementById("bundle_procon").getString("ConfirmRemove"));
 if(k){
 var urls = document.getElementById("bundle_regex").getString("defaulturlregex");
 oPrefs.setCharPref("procon.urlregex", urls);
 var words = document.getElementById("bundle_regex").getString("defaultwordregex");
 oPrefs.setCharPref("procon.wordregex", words);
 var profanity = document.getElementById("bundle_regex").getString("defaultprofanity");
 oPrefs.setCharPref("procon.wordlist", profanity);
 var value2 = oPrefs.getComplexValue("procon.wordlist",
      Components.interfaces.nsISupportsString).data;
 document.getElementById("wordList").value = value2;
 }
}

function editExp() {
   window.openDialog("chrome://procon/content/editExp.xul", "editExp", "chrome,centerscreen,resizable,modal");
}

function setPass() {
   window.openDialog("chrome://procon/content/password.xul", "proconPass", "chrome,centerscreen,resizable=no,modal");
}

function addCurrent() {
var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow)
var url = mainWindow.opener.content.location.hostname;
url = url.replace("www.","");
document.getElementById("whiteList").value = document.getElementById("whiteList").value + "\n" + url ;
}

function onAccept() {
	/*I removed this frikin' code because I thought prefWindows were better
	in managing each preference. Result: They screwed a big part of my work...
	I really needed that the Mozilla documentation would point out that they
	behave differently (crappier on other platforms). What a piece of ****!
	(yeah see ProCon cesured its author...)... oh well...*/
	oPrefs.setBoolPref("procon.htm", document.getElementById("pref-hideTM").checked);
	oPrefs.setBoolPref("procon.pstatus", document.getElementById("pref-statusbar").checked);
	oPrefs.setBoolPref("procon.addons", document.getElementById("pref-addons").checked);
	oPrefs.setBoolPref("procon.abl", document.getElementById("pref-aboutconfig").checked);
	oPrefs.setBoolPref("procon.enableRealTime", document.getElementById("pref-enableRealTime").checked);
	oPrefs.setBoolPref("procon.enableRealTimeWhiteList", document.getElementById("pref-enableRealTimeWhiteList").checked);
	oPrefs.setCharPref("procon.shortcut", document.getElementById("shortcut").value);
	oPrefs.setBoolPref("procon.enabled", document.getElementById("enabled").checked);
	oPrefs.setBoolPref("procon.bat", document.getElementById("stopAll").checked);
	oPrefs.setCharPref("procon.psit", document.getElementById("psit").value);
	if (document.getElementById("psit").value === ""){
	  oPrefs.setBoolPref("procon.pcust", false);
	  }else{
	  oPrefs.setBoolPref("procon.pcust", document.getElementById("pcust").checked);
	  }
	oPrefs.setBoolPref("procon.enableWhiteList", document.getElementById("trustedcheck").checked);
	oPrefs.setBoolPref("procon.filteron", document.getElementById("profanitycheck").checked);
	
	var group = document.getElementById("levels");
    var selected = group.value;
	oPrefs.setIntPref("procon.lvl", selected);
	
   var str = Components.classes["@mozilla.org/supports-string;1"]
      .createInstance(Components.interfaces.nsISupportsString);
str.data = document.getElementById("whiteList").value;
oPrefs.setComplexValue("procon.whiteList", 
      Components.interfaces.nsISupportsString, str);  
if (document.getElementById("whiteList").value === ""){
      oPrefs.clearUserPref("procon.whiteList");
	  oPrefs.setBoolPref("procon.enableWhiteList", false);
	  }
	  
	var strProfanity = Components.classes["@mozilla.org/supports-string;1"]
      .createInstance(Components.interfaces.nsISupportsString);
strProfanity.data = document.getElementById("wordList").value;
oPrefs.setComplexValue("procon.wordlist", 
      Components.interfaces.nsISupportsString, strProfanity);
if (document.getElementById("wordList").value === ""){
      oPrefs.clearUserPref("procon.wordlist");
	  oPrefs.setBoolPref("procon.filteron", false);
	  }
	  
	  	var strcustomProf = Components.classes["@mozilla.org/supports-string;1"]
      .createInstance(Components.interfaces.nsISupportsString);
strcustomProf.data = document.getElementById("customCens").value;
oPrefs.setComplexValue("procon.customCens", 
      Components.interfaces.nsISupportsString, strcustomProf);
if (document.getElementById("customCens").value === ""){
strcustomProf.data = "***";
     oPrefs.setComplexValue("procon.customCens", 
      Components.interfaces.nsISupportsString, strcustomProf);
	  }
}

function unLoad() {
	oPrefs.setBoolPref("procon.authenticated", false);
}
